﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type Message (Address As String, Body As String)
	
	Dim Broadcast As BroadCastReceiver
	
End Sub
Sub Service_Create
	Log("ServiceCreate")
	Broadcast.Initialize("BroadcastReceiver")
End Sub

Sub Service_Start (StartingIntent As Intent)
Log("service_start")
Broadcast.addAction("android.provider.Telephony.SMS_RECEIVED")
Broadcast.addAction(Broadcast.SMS_RECEIVED)
Broadcast.SetPriority(999)
Broadcast.registerReceiver("")

      Dim messages() As Message
      messages = ParseSmsIntent(StartingIntent)																																																										
      For I = 0 To messages.Length - 1
         Log("Logged in Service_Start: "&messages(I))
      Next
Log("serviceStart completed")
End Sub

Sub BroadcastReceiver_OnReceive (Action As String,BroadcastIntent As Object)
	Log("into BroadcastReceiver")
      Dim messages() As Message
      messages = ParseSmsIntent(BroadcastIntent)																																																										
      For I = 0 To messages.Length - 1
         Log("Logged in BroadcastReceiver_OnReceive"&messages(I))
      Next
Log("received sms")
Log(Action)
Broadcast.AbortBroadcast
End Sub

'Parses an SMS intent and returns an array of messages
Sub ParseSmsIntent (In As Intent) As Message()
Log("into parseSMSintent")
   Dim messages() As Message
   If In.HasExtra("pdus") = False Then Return messages
   Dim pdus() As Object
   Dim r As Reflector
   pdus = In.GetExtra("pdus")
   If pdus.Length > 0 Then
      Dim messages(pdus.Length) As Message
      For i = 0 To pdus.Length - 1
         r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", _
            Array As Object(pdus(i)), Array As String("[B"))
         messages(i).Body = r.RunMethod("getMessageBody")
         messages(i).Address = r.RunMethod("getOriginatingAddress")
	'	 Log(messages(i).Body)
	'	 Log(messages(i).Address)
		 
      Next
   End If
   Return messages
   Log("parseSMSintent completed")
End Sub

Sub Service_Destroy

End Sub
